import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class BG extends World
{

    public Cube wuerfel;
    
    private Tile[][] tilesLinks;
    private Tile[][] tilesRechts;
    private Tile[][] tilesOben;
    
    private boolean keyactive;
    
    public BG()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 500, 1); 
        
        keyactive = false;
        
        int startx = 350;
        int starty = 250;
        
        tilesLinks = new Tile[3][3];
        tilesRechts = new Tile[3][3];
        tilesOben = new Tile[3][3];
        
        // rechte/linke seite
        //    erste koord. fuer x, zweite fuer y wert
        // obere seite
        //    erste zeile (xkoord) geht von links nach oben
        for(int i=0;i<3;i++) {
            for(int j=0;j<3;j++) {
                tilesRechts[i][j] = new Tile(Tile.BLAU, Tile.RIGHT);
                addObject(tilesRechts[i][j],startx+j*52,starty-j*26+i*52);
                
                tilesLinks[i][j] = new Tile(Tile.ORANGE, Tile.LEFT);
                addObject(tilesLinks[i][j],startx-52-j*52,starty-j*26+i*52);
                
                tilesOben[i][j] = new Tile(Tile.GELB, Tile.UP);
                addObject(tilesOben[i][j],startx-142+i*52+j*52,starty-92+i*26-j*26);
            }
        }
        
        wuerfel = new Cube();
        addObject(wuerfel,50,50);
        wuerfel.connectToWorld(this);
        updateView();
        
    }
    
    public void updateView() {
        if (wuerfel!=null) {
            for(int i=0;i<3;i++) for(int j=0;j<3;j++)
                tilesRechts[i][j].setzeFarbe(wuerfel.getColor(Cube.RECHTS,i,j));
            for(int i=0;i<3;i++) for(int j=0;j<3;j++)
                tilesLinks[i][2-j].setzeFarbe(wuerfel.getColor(Cube.VORNE,i,j));
            tilesOben[0][0].setzeFarbe(wuerfel.getColor(Cube.OBEN,2,0));
            tilesOben[0][1].setzeFarbe(wuerfel.getColor(Cube.OBEN,1,0));
            tilesOben[0][2].setzeFarbe(wuerfel.getColor(Cube.OBEN,0,0));
            tilesOben[1][0].setzeFarbe(wuerfel.getColor(Cube.OBEN,2,1));
            tilesOben[1][1].setzeFarbe(wuerfel.getColor(Cube.OBEN,1,1));
            tilesOben[1][2].setzeFarbe(wuerfel.getColor(Cube.OBEN,0,1));
            tilesOben[2][0].setzeFarbe(wuerfel.getColor(Cube.OBEN,2,2));
            tilesOben[2][1].setzeFarbe(wuerfel.getColor(Cube.OBEN,1,2));
            tilesOben[2][2].setzeFarbe(wuerfel.getColor(Cube.OBEN,0,2));
        }
    }
    
    public void act() {
        String s = Greenfoot.getKey();
        if (s != null) {
            if      (s.equals("u")) wuerfel.up();
            else if (s.equals("U")) wuerfel.upInverse();
            else if (s.equals("d")) wuerfel.down();
            else if (s.equals("D")) wuerfel.downInverse();
            else if (s.equals("l")) wuerfel.left();
            else if (s.equals("L")) wuerfel.leftInverse();
            else if (s.equals("r")) wuerfel.right();
            else if (s.equals("R")) wuerfel.rightInverse();
            else if (s.equals("f")) wuerfel.front();
            else if (s.equals("F")) wuerfel.frontInverse();
            else if (s.equals("b")) wuerfel.back();
            else if (s.equals("B")) wuerfel.backInverse();
            else if (s.equals("m")) wuerfel.middle();
            else if (s.equals("M")) wuerfel.middleInverse();
            else if (s.equals("e")) wuerfel.equator();
            else if (s.equals("E")) wuerfel.equatorInverse();
            else if (s.equals("s")) wuerfel.standing();
            else if (s.equals("S")) wuerfel.standingInverse();
            else if (s.equals("x")) wuerfel.xCubeRotate();
            else if (s.equals("X")) {wuerfel.xCubeRotate();wuerfel.xCubeRotate();wuerfel.xCubeRotate();}
            else if (s.equals("y")) wuerfel.yCubeRotate();
            else if (s.equals("Y")) {wuerfel.yCubeRotate();wuerfel.yCubeRotate();wuerfel.yCubeRotate();}
            else if (s.equals("z")) wuerfel.zCubeRotate();
            else if (s.equals("Z")) {wuerfel.zCubeRotate();wuerfel.zCubeRotate();wuerfel.zCubeRotate();}
            else if (s.equals("q")) wuerfel.scramble();
            //else if (s.equals("p")) wuerfel.pochmannLoesung();
        }
    }
    

}
