import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class Tile extends Actor
{
    public final static int ROT   =0;
    public final static int BLAU  =1;
    public final static int GELB  =2;
    public final static int WEISS =3;
    public final static int GRUEN =4;
    public final static int ORANGE=5;
    
    public final static int RIGHT=0;
    public final static int LEFT=1;
    public final static int UP=2;
    
    private int farbcode;
    private GreenfootImage bgimage;
    private int[ ] xkoords;
    private int[ ] ykoords;
    
    public Tile(int farbcode, int ausrichtung) {
        bgimage = new GreenfootImage(75,75);
        setImage(bgimage);
        setzeAusrichtung(ausrichtung);
        setzeFarbe(farbcode);
    }
    
    public void setzeAusrichtung(int code) {
        bgimage.clear();
        if (code==LEFT) {
            bgimage = new GreenfootImage(75,75);
            int[] xkoordstmp = {50, 0, 0,50};
            int[] ykoordstmp = {25, 0,50,75};
            xkoords = xkoordstmp;
            ykoords = ykoordstmp;
            setzeFarbe(farbcode);
            setImage(bgimage);
        } else if (code==RIGHT) {
            bgimage = new GreenfootImage(75,75);
            int[] xkoordstmp = { 0,50,50, 0};
            int[] ykoordstmp = {25, 0,50,75};
            xkoords = xkoordstmp;
            ykoords = ykoordstmp;
            setzeFarbe(farbcode);
            setImage(bgimage);
        } else {
            //oben
            bgimage = new GreenfootImage(100,50);
            int[] xkoordstmp = { 0,50,100,50};
            int[] ykoordstmp = {25,50, 25, 0};
            xkoords = xkoordstmp;
            ykoords = ykoordstmp;
            setzeFarbe(farbcode);
            setImage(bgimage);
        }
        bgimage.fillPolygon(xkoords,ykoords,4);
    }
    
    public void setzeFarbe(int neueFarbe) {
        farbcode = neueFarbe;
        switch(farbcode) {
            case ROT: bgimage.setColor(Color.red);break;
            case ORANGE: bgimage.setColor(new Color(255,140,0));break;
            case GRUEN: bgimage.setColor(Color.green);break;
            case BLAU: bgimage.setColor(Color.blue);break;
            case GELB: bgimage.setColor(Color.yellow);break;
            case WEISS: bgimage.setColor(Color.white);
        }
        bgimage.fillPolygon(xkoords,ykoords,4);
    }
    
    public int getColor() {
        return farbcode;
    }
    

}
